#note this package is not prefixable
%define prefix /usr
%define name vim
%define version 5.6
%define release 18mdk
%define url ftp://ftp.vim.org/pub/vim/unix/

Summary: VIsual editor iMproved 
Name: %{name}
Version: %{version}
Release: %{release}
Source0: %{url}/%{name}-%{version}-src.tar.bz2
Source1: %{url}/%{name}-%{version}-rt.tar.bz2
Source2: gvim.menu.bz2
Patch0: vim-4.2-speed_t.patch.bz2
Patch1: vim-5.4-tutor.patch.bz2
Patch2: vim-5.1-vimnotvi.patch.bz2
Patch3: vim-typo.patch.bz2
Patch4: vimrc_hebrew.patch.bz2
Patch5: vim_vimrc.patch.bz2
Patch6: vim-5.6-perl5.6.patch.bz2
Patch7: vim-5.6-nowrap.patch.bz2
Copyright: OpenSource
Group: Editors
BuildRoot: %{_tmppath}/%{name}-%{version}

%description
VIM (VIsual editor iMproved) is an updated and improved version of the vi
editor.  Vi was the first real screen-based editor for UNIX, and is still
very popular.  VIM improves on vi by adding new features: multiple windows,
multi-level undo, block highlighting and more.  The vim-common package
contains files which every VIM binary will need in order to run.

%package -n ctags
Version: 3.4
Summary: Generates an index (or "tag") file for objects found in source files. 
Group: Editors

%description -n ctags
The ctags program generate an index (or "tag") file for C, C++, Eiffel,
Fortran, and Java language objects found in files.  This tag file allows
these items to be quickly and easily located by a text editor or other
utility.  A "tag" signifies a language object for which an index entry is
available (or, alternatively, the index entry created for that object).

Alternatively, ctags can generate a cross reference file which lists, in
human readable form, information about the various source objects found in
a set of language files.

%package common
Summary: The common files needed by any version of the VIM editor.
Group: Editors
Requires: ctags

%description common
VIM (VIsual editor iMproved) is an updated and improved version of the vi
editor.  Vi was the first real screen-based editor for UNIX, and is still
very popular.  VIM improves on vi by adding new features: multiple windows,
multi-level undo, block highlighting and more.  The vim-common package
contains files which every VIM binary will need in order to run.

If you are installing any version of the VIM editor, you'll also need to
the vim-common package installed.

%package minimal
Summary: A minimal version of the VIM editor.
Group: Editors
Provides: vim

%description minimal
VIM (VIsual editor iMproved) is an updated and improved version of the vi
editor.  Vi was the first real screen-based editor for UNIX, and is still
very popular.  VIM improves on vi by adding new features: multiple windows,
multi-level undo, block highlighting and more.  The vim-minimal package
includes a minimal version of VIM, which is installed into /bin/vi for use
when only the root partition is present.

%package enhanced
Summary: A version of the VIM editor which includes recent enhancements.
Group: Editors
Requires: vim-common
Obsoletes: vim-color
Provides: vim

%description enhanced
VIM (VIsual editor iMproved) is an updated and improved version of the vi
editor.  Vi was the first real screen-based editor for UNIX, and is still
very popular.  VIM improves on vi by adding new features: multiple windows,
multi-level undo, block highlighting and more.  The vim-enhanced package
contains a version of VIM with extra, recently introduced features like
Python and Perl interpreters.

Install the vim-enhanced package if you'd like to use a version of the VIM
editor which includes recently added enhancements like interpreters for the
Python and Perl scripting languages.  You'll also need to install the
vim-common package.

%package X11
Summary: The VIM version of the vi editor for the X Window System.
Summary(de): VIM-Version fuer X11.
Group: Editors
Provides: vim
Requires: vim-common gtk+ >= 1.2.3

%description X11
VIM (VIsual editor iMproved) is an updated and improved version of the vi
editor.  Vi was the first real screen-based editor for UNIX, and is still
very popular.  VIM improves on vi by adding new features: multiple windows,
multi-level undo, block highlighting and more. VIM-X11 is a version of the
VIM editor which will run within the X Window System.  If you install this
package, you can run VIM as an X application with a full GUI interface and
mouse support.

Install the vim-X11 package if you'd like to try out a version of vi with
graphics and mouse capabilities.  You'll also need to install the
vim-common package.

%prep
%setup -q -b 1 
%patch0 -p1 -b .speed_t
%patch1 -p0 -b .tutor
%patch2 -p1 -b .vimnotvi
%patch3 -p1 -b .suck
%patch4 -p1
%patch5 -p1 -b .ddx_config
%patch6 -p1
%patch7 -p1 -b .nowrap

%build

#
CXXFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{prefix} \
--enable-pythoninterp --enable-perlinterp --enable-max-features \
--with-x=yes --enable-gui=gtk --exec-prefix=%{prefix}/X11R6 \
--enable-multibyte --enable-xim --enable-fontset
echo "#define MAX_FEAT 1" >> src/config.h
uname -a|grep -qi SMP && make -j 2 || make

(
    cd src
    mv vim gvim
    make clean
)

#
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS"  ./configure --prefix=%{prefix} \
--enable-pythoninterp --enable-perlinterp --enable-max-features \
--with-x=no --enable-gui=no --exec-prefix=%{prefix}

uname -a|grep -qi SMP && make -j 2 || make

(
    cd src
    mv vim enhanced-vim
    make clean
)

#
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" ./configure  --prefix=%{prefix} \
--disable-pythoninterp --disable-perlinterp \
--with-x=no --enable-gui=no --exec-prefix=%{prefix} --with-tlib=termcap --disable-gpm --exec-prefix=/

uname -a|grep -qi SMP && make -j 2 || make

(
    cd src
    make
)
%install
mkdir -p $RPM_BUILD_ROOT/bin
mkdir -p $RPM_BUILD_ROOT/%{prefix}/{bin,man/man1,share/vim,X11R6/bin}

cd src
make prefix=$RPM_BUILD_ROOT/%{prefix} exec_prefix=$RPM_BUILD_ROOT install VIMRTDIR=""

mv $RPM_BUILD_ROOT/bin/xxd $RPM_BUILD_ROOT/%{prefix}/bin

make installmacros prefix=$RPM_BUILD_ROOT/%{prefix} VIMRTDIR=""

install -s -m755 gvim $RPM_BUILD_ROOT/%{prefix}/X11R6/bin
install -s -m755 enhanced-vim $RPM_BUILD_ROOT/%{prefix}/bin/vim
install -s -m755 $RPM_BUILD_ROOT/bin/ctags $RPM_BUILD_ROOT/usr/bin/ctags

( 
  cd $RPM_BUILD_ROOT
  mv -f ./bin/vim ./bin/vi
  rm -f ./bin/rvim
  ln -sf vi ./bin/view
  ln -sf vi ./bin/ex
  ln -sf vi ./bin/rvi
  ln -sf vi ./bin/rview
  ln -sf vim ./usr/bin/vi
  ln -sf vim ./usr/bin/ex
  rm -f ./usr/man/man1/rvim.1.bz2
  ln -sf gvim ./usr/X11R6/bin/vimx
)

# installing man pages
(
  cd $RPM_BUILD_ROOT/usr/man/man1
  for i in vi rvi gvim ex rview rvim view; do
    rm -f $i.1
    ln -sf vim.1.bz2 $i.1.bz2
  done
)

rm -rf $RPM_BUILD_ROOT/%{prefix}/share/vim/doc/
ln -sf ../../doc/vim-common-5.6/doc $RPM_BUILD_ROOT/usr/share/vim/

(
  cd $RPM_BUILD_ROOT/usr/share/vim
  ln -sf vimrc_example.vim vimrc
)

(
    cd $RPM_BUILD_ROOT/%{prefix}/share/vim/tools
    # i need to make a choice :(.
    rm -f vim132
    perl -p -i -e 's|#!/usr/bin/nawk|#!/usr/bin/gawk|' mve.awk
    perl -p -i -e 's|#!/usr/local/bin/perl|#!/usr/bin/perl|' *.pl
    perl -p -i -e 's|#!/usr/gnu/bin/perl|#!/usr/bin/perl|' *
)
    
cd ..
mv runtime/macros/README.txt README_macros.txt
mv runtime/tools/README.txt README_tools.txt
mv runtime/doc .
perl -p -i -e "s|#!/usr/local/bin/perl|#!/usr/bin/perl|" doc/*.pl

# installing the three icons
mkdir -p $RPM_BUILD_ROOT/%{prefix}/share/icons/mini
mkdir -p $RPM_BUILD_ROOT/%{prefix}/share/icons/large
cp runtime/vim16x16.xpm $RPM_BUILD_ROOT/%{prefix}/share/icons/mini/gvim.xpm
cp runtime/vim32x32.xpm $RPM_BUILD_ROOT/%{prefix}/share/icons/gvim.xpm
cp runtime/vim48x48.xpm $RPM_BUILD_ROOT/%{prefix}/share/icons/large/gvim.xpm

mkdir -p $RPM_BUILD_ROOT/%{prefix}/lib/menu
bzcat %{SOURCE2} > $RPM_BUILD_ROOT/%{prefix}/lib/menu/vim-X11

%post minimal
[ -e /usr/bin/vi ] || ln -s /bin/vi /usr/bin/vi

%post enhanced
[ -e /bin/vi ] || ln  -s /usr/bin/vim /bin/vi

# This is for the menu...
%post X11
## menu
if [ -x /usr/bin/update-menus ]; then
  /usr/bin/update-menus
fi

%postun X11
## menu
if [ "$1" = 0 ]; then
  if [ -x /usr/bin/update-menus ]; then
    /usr/bin/update-menus
  fi
fi


%clean
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/$RPM_PACKAGE_NAME

%files -n ctags
%defattr(-,root,root)
/usr/bin/ctags
%{prefix}/man/man1/ctags.1*

%files common
%defattr(-,root,root)
%doc README*.txt runtime/gvimrc_example.vim runtime/bugreport.vim 
%doc runtime/menu.vim runtime/mswin.vim doc
%doc runtime/termcap runtime/tutor runtime/vimrc_example.vim vimrc_hebrew

%{prefix}/share/vim
%{prefix}/man/man1/vim.1*
%{prefix}/man/man1/ex.1*
%{prefix}/man/man1/vi.1*
%{prefix}/man/man1/view.1*
%{prefix}/man/man1/rvi.1*
%{prefix}/man/man1/rview.1*
%{prefix}/bin/xxd
%{prefix}/man/man1/xxd.1*

%files minimal
%defattr(-,root,root)
/bin/ex
/bin/vi
/bin/view
/bin/rvi
/bin/rview

%files enhanced
%defattr(-,root,root)
%{prefix}/bin/vim
%{prefix}/bin/vi
%{prefix}/bin/ex

%files X11
%defattr(-,root,root)
%{prefix}/X11R6/bin/gvim
%{prefix}/X11R6/bin/vimx
%{prefix}/man/man1/gvim.1*
%{prefix}/share/icons/gvim.xpm
%{prefix}/share/icons/mini/gvim.xpm
%{prefix}/share/icons/large/gvim.xpm
%{prefix}/lib/menu/vim-X11

%changelog
* Tue May  2 2000 DindinX <odin@mandrakesoft.com> 5.6-18mdk
- wrap option now defaults to FALSE

* Fri Apr 28 2000 DindinX <odin@mandrakesoft.com> 5.6-17mdk
- remove menu icon path

* Tue Apr 18 2000 Pixel <pixel@mandrakesoft.com> 5.6-16mdk
- fix for perl 5.6
- fix for ctags (i modified patch vim-typo)
- rebuild on true compile box (*with* spec-helper)
- remove abusive provides ctags (not needed)

* Tue Apr 18 2000 DindinX <odin@mandrakesoft.com> 5.6-15mdk
- Fix the online documentation

* Tue Apr 18 2000 DindinX <odin@mandrakesoft.com> 5.6-14mdk
- Make a separate rpm for ctags

* Mon Apr 17 2000 DindinX <odin@mandrakesoft.com> 5.6-13mdk
- fix the name of the menu entry
- remove etags
- move ctags from /bin to /usr/bin
- Added the ctags man page

* Tue Mar 28 2000 DindinX <odin@mandrakesoft.com> 5.6-12mdk
- Do the Right Thing for the menus with the help of 
  Guillaume Cottenceau

* Tue Mar 28 2000 DindinX <odin@mandrakesoft.com> 5.6-11mdk
- Fix the menu group once again (sic)
  Thanks to Guillaume Cottenceau

* Mon Mar 27 2000 DindinX <odin@mandrakesoft.com> 5.6-10mdk
- Added icons

* Mon Mar 27 2000 DindinX <odin@mandrakesoft.com> 5.6-9mdk
- fix menu

* Fri Mar 24 2000 DindinX <odin@mandrakesoft.com> 5.6-8mdk
- remove the RPM_ROOT_BUILD references in %post
  (thanks to Thierry Vignaud for pointing this)
- some changes to the default vimrc
  
* Wed Mar 22 2000 Pixel <pixel@mandrakesoft.com> 5.6-7mdk
- add provides vim for X11 enhanced and minimal
- changed license from freeware to OpenSource

* Mon Mar 20 2000 DindinX <odin@mandrakesoft.com> 5.6-6mdk
- Specs fixes
- removed absolute links
- Added menu entry
- Remove the hlsearch by default (cause it might be puzzling)

* Thu Feb 10 2000 DindinX <odin@mandrakesoft.com> 5.6-5mdk
- Finally include ctags in vim-common :-/

* Thu Feb 10 2000 DindinX <odin@mandrakesoft.com> 5.6-4mdk
- fix a typo in the call to the ./configure script so more features
  are now enabled.

* Sun Feb  6 2000 DindinX <odin@mandrakesoft.com> 5.6-3mdk
- Added support for Chinese/Japanese/Corean support for gvim
  (Thanks to Pablo)
- added a link for the default vimrc.

* Mon Jan 31 2000 DindinX <odin@mandrakesoft.com> 5.6-2mdk
- Added the doc/ subdirectory in /usr/doc/vim-common-5.6/doc
- Correctly install vimrc_hebrew

* Sun Jan 16 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 5.6-1mdk
- 5.6.
- Enable right to left mode.
- Add vimrc_hebrew from Tzafrir Cohen <tzafrir@technion.ac.il>

* Tue Oct 26 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- Build release.

* Tue Sep 21 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- 5.5.

* Mon Aug  2 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- Reinserting old patch.

* Thu Jul 29 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- First spec file for Mandrake distribution.


# end of file
